// QQDlg.cpp : implementation file
//

#include "stdafx.h"
#include <windows.h>
#include <TLHELP32.H>
#include <tchar.h>
#include "QQ.h"
#include "QQDlg.h"
#include <shlwapi.h>

#define IDT_READMEM 11011						// ݶʱID
#define IDT_FINDGAMEWINDOW 11012				// ϷڶʱID

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CQQDlg dialog

CQQDlg::CQQDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CQQDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CQQDlg)
	m_edt_csMySelf = _T("");
	m_edt_csLeft = _T("");
	m_edt_csRight = _T("");
	m_edt_csBomb = _T("");
	m_edt_csNotPlayedLeft = _T("");
	m_edt_csNotPlayedRight = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CQQDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CQQDlg)
	DDX_Text(pDX, IDC_EDT_MYSELF, m_edt_csMySelf);
	DDX_Text(pDX, IDC_EDT_LEFT, m_edt_csLeft);
	DDX_Text(pDX, IDC_EDT_RIGHT, m_edt_csRight);
	DDX_Text(pDX, IDC_EDT_BOMB, m_edt_csBomb);
	DDX_Text(pDX, IDC_EDT_PLAYED_LEFT, m_edt_csNotPlayedLeft);
	DDX_Text(pDX, IDC_EDT_PLAYED_RIGHT, m_edt_csNotPlayedRight);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CQQDlg, CDialog)
	//{{AFX_MSG_MAP(CQQDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CQQDlg message handlers

BOOL CQQDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	SetTimer( IDT_FINDGAMEWINDOW, 2000, NULL );
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CQQDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CQQDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CQQDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void IsGameStart( HANDLE hOpenHandle );
DWORD GetModuleBase( TCHAR *pStr, BOOL bWindowName, TCHAR *pModleName );
DWORD  UpToData( );
void ReadData( HANDLE hOpenHandle, int iRead, int iIndex );
void InitBase();

TCHAR *pStr = _T("QQϷ - ֶ")  ;
TCHAR *pModuleName = _T("GameLogic.dll");

HWND hFindWindow = NULL;		// ¼Ϸھ

BYTE bySqueezerCourrentNum[3] = { 0, 0, 0 };				    // ǰʣ
BYTE bySqueezerOldNum[3] = { 0, 0, 0 };						// ǰʣ
// Ƶ 
// dwSqueezerData[0] λΪ2
//  dwSqueezerData[1] λΪ0
//   dwSqueezerData[0] λΪ1
DWORD arrdwSqueezerData[3][20];	
// Ѵ
BYTE arrbyNotPlayedSqueezerData[2][15];
// ܴը
// A - arrBomb[1] 2 Ӧ arrBomb[2];
// Ϊ1ʾըΪ0ʾûը
BYTE arrBomb[15] = { 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 } ;
					
DWORD dwLeftBase = 0, dwRightBase = 0, dwDownBase = 0;		// Ƶڴַ
// ƵϢȻֻԼеǿɼĹ;
BYTE arrMySqueezerData[20];
// ԼеһƵĻַ, Ϊλ3ַҲ3
DWORD dwMySqueezerDataBase[3] = { 0, 0, 0 };;
// ڳеҴλ, ͵ַ
BYTE byPlayingSeatID = 0;
DWORD dwPlayingSeatIDBase = 0;	
// ҵĴλţ ͵ַ
BYTE byMySeatID = 0; 
DWORD dwMySeatIDBase = 0;		
 // ԾƵλţ ͵ַ;
BYTE byPlayedSeatID =0; 
DWORD dwPlayedSeatIDBase = 0;  

// Ϸλڴλ
// dwPosToSeat[0] Ϸ߶Ծʹλ
//  dwPosToSeat[1] ϷҶԾʹλ
//   dwPosToSeat[0] Ϸ±߶Ծʹλ
DWORD dwPosToSeat[3] = { 0, 0, 0 };		


BOOL bGameStart = FALSE;								// ʾϷǷʼ
DWORD dwGameLogicDllBase = 0;							// GameLogic.dll Ļַ
HANDLE hOpenHandle = NULL;							// ϷȨ޾
DWORD dwRet = 0;		// Ҫʾ͸µEDIT± iRet = 0; ʾ ҪµdwSqueezerData±iRet - 1;
DWORD dwPlayedTimes = 0;	// ¼ڼγ, Ϸλ


// õ򿪽Ȩ޾
// صһstatic 
// 
HANDLE GetGameOpenHandl( TCHAR *pStr, BOOL bWindowName = TRUE )
{
	HWND hWnd;
	static HANDLE hOpenHandle;
	if ( bWindowName )
		hWnd = FindWindow( NULL, pStr );
	else
		hWnd = FindWindow( pStr, NULL );
	if ( hWnd != NULL  )
	{
		DWORD dwProcessID;
		GetWindowThreadProcessId( hWnd, &dwProcessID );
		hOpenHandle = OpenProcess( PROCESS_VM_READ, FALSE, dwProcessID );
		if ( hOpenHandle != NULL )
		{
			return hOpenHandle;
		}
	}

	return NULL;

}


void CQQDlg::OnBtnStart() 
{
	// TODO: Add your control notification handler code here

}

// ȡƵ
// hOpenHandle 򿪽Ȩ޾
// iRed ʾһִ˶,  ҲҪ¶ٸ
// iIndexʾҪµǸҵ
//  

void ReadData( HANDLE hOpenHandle, int iRead, int iIndex )
{
	DWORD dwRealRead;
	int i, j;
	// ȡҵ
	ReadProcessMemory( hOpenHandle, LPVOID(dwLeftBase-0x339),  LPVOID(&bySqueezerCourrentNum[0]), 1, &dwRealRead  );
	ReadProcessMemory( hOpenHandle, LPVOID(dwRightBase-0x339),  LPVOID(&bySqueezerCourrentNum[1]), 1, &dwRealRead  );
	ReadProcessMemory( hOpenHandle, LPVOID(dwDownBase-0x339),  LPVOID(&bySqueezerCourrentNum[2]), 1, &dwRealRead  );
	
	if ( iRead > 0 )
	{
		// ڵһγɺϷңµλúʹĵλӦ
		// ΪǺʹλ
		if ( dwPlayedTimes == 1 )
		{
			ReadProcessMemory( hOpenHandle, LPVOID(dwMySeatIDBase ),  LPVOID(&byMySeatID ), 1, &dwRealRead  );
			ReadProcessMemory( hOpenHandle, LPVOID(dwPlayedSeatIDBase ),  LPVOID(&byPlayedSeatID ), 1, &dwRealRead  );
			ReadProcessMemory( hOpenHandle, LPVOID(dwPlayingSeatIDBase ),  LPVOID(&byPlayingSeatID ), 1, &dwRealRead  );
			// ȱʾǵ
			if ( byMySeatID == byPlayingSeatID  )
			{
				// ϷλúλӦ
				dwPosToSeat[0] = byPlayedSeatID;
				dwPosToSeat[2] = byPlayingSeatID;
				dwPosToSeat[1] = 3 - byPlayedSeatID - byPlayingSeatID;
			}
			// ʾǵ
			else if ( byMySeatID == byPlayedSeatID  )
			{
				dwPosToSeat[2] = byPlayedSeatID;
				dwPosToSeat[1] = byPlayingSeatID;
				dwPosToSeat[0] = 3 - byPlayedSeatID - byPlayingSeatID;
			}
			else	// ʾұǵ
			{
				dwPosToSeat[1] = byPlayedSeatID;
				dwPosToSeat[0] = byPlayingSeatID;
				dwPosToSeat[2] = 3 - byPlayedSeatID - byPlayingSeatID;
			}
		}
		for(  i= 0, j = 0xC; i < iRead; i++ )
		{
			if ( 0 == iIndex )
			{
				ReadProcessMemory( hOpenHandle, LPVOID(dwLeftBase + i * j ),  LPVOID(&arrdwSqueezerData[0][i] ), 4, &dwRealRead  );
			}
			if ( 1 == iIndex )
			{
				ReadProcessMemory( hOpenHandle, LPVOID(dwRightBase + i * j ),  LPVOID(&arrdwSqueezerData[1][i] ), 4, &dwRealRead  );
			}
			if ( 2 == iIndex )
			{
				ReadProcessMemory( hOpenHandle, LPVOID(dwDownBase + i * j ),  LPVOID(&arrdwSqueezerData[2][i] ), 4, &dwRealRead  );
			}
		}
	}

}

// жǷ,  ³ݵdwSqueezerData[][], Ѹݵ±+1,
DWORD  UpToData( )
{
	// ReadData( hOpenHandle, 0, 3 ) ֻ
	ReadData( hOpenHandle, 0, 3 );

	if ( bySqueezerCourrentNum[0] != bySqueezerOldNum[0]  )
	{
		++dwPlayedTimes;
		ReadData( hOpenHandle,   bySqueezerOldNum[0] - bySqueezerCourrentNum[0], 0 );
		// Ժǰһ == ǰ
		bySqueezerOldNum[0] = bySqueezerCourrentNum[0];
		return 3;
	}
	else if ( bySqueezerCourrentNum[1] != bySqueezerOldNum[1] )
	{
		++dwPlayedTimes;
		ReadData( hOpenHandle,   bySqueezerOldNum[1] - bySqueezerCourrentNum[1], 1 );
		bySqueezerOldNum[1] = bySqueezerCourrentNum[1];
		return 1;
	}
	else if ( bySqueezerCourrentNum[2] != bySqueezerOldNum[2]  )
	{
		++dwPlayedTimes;
		ReadData( hOpenHandle,   bySqueezerOldNum[2] - bySqueezerCourrentNum[2], 2 );
		bySqueezerOldNum[2] = bySqueezerCourrentNum[2];
		return 2;
	}
	return 0;
}

void InitBase()
{	
	// ݵַ
	dwLeftBase = dwGameLogicDllBase + 0xEB505;
	dwRightBase = dwGameLogicDllBase + 0xEA265;
	dwDownBase = dwGameLogicDllBase + 0xEABB5;

	// ڳеҵĴλŵַ
	dwPlayingSeatIDBase = dwGameLogicDllBase+0xEC0D4;
	// ԾƵλ
	dwPlayedSeatIDBase = dwGameLogicDllBase+0xEC0D0;
	// Լλ
	dwMySeatIDBase = dwGameLogicDllBase + 0xF2888;

	// ԼƵĻַ
	// 
	dwMySqueezerDataBase[0] = dwGameLogicDllBase + 0xeb1fd;
	// ұ
	dwMySqueezerDataBase[1] = dwGameLogicDllBase + 0xe9f5d;
	// ±
	dwMySqueezerDataBase[2] = dwGameLogicDllBase + 0xea8ad;

}

// жǷ
void IsGameStart( HANDLE hOpenHandle )
{
	DWORD dwRealRead;
	DWORD dwBak = 0x2001e;

	// ȡҵ
	ReadProcessMemory( hOpenHandle, LPVOID(dwLeftBase-0x339),  LPVOID(&bySqueezerCourrentNum[0]), 1, &dwRealRead  );
	ReadProcessMemory( hOpenHandle, LPVOID(dwRightBase-0x339),  LPVOID(&bySqueezerCourrentNum[1]), 1, &dwRealRead  );
	ReadProcessMemory( hOpenHandle, LPVOID(dwDownBase-0x339),  LPVOID(&bySqueezerCourrentNum[2]), 1, &dwRealRead  );
	
	if ( bySqueezerCourrentNum[0] == 20 || bySqueezerCourrentNum[1] == 20 || bySqueezerCourrentNum[2] == 20 )
	{
		// ʼ£ΪTRUE
		bGameStart = TRUE;
		// õǰǰһ
		for ( int i = 0; i < 3; i++ )
		{
			bySqueezerOldNum[i] = bySqueezerCourrentNum[i];
		}
		// Ѵ
		memset( arrbyNotPlayedSqueezerData, 1, 2*15 );
		// 
		// һʼʼ涼ը
		for ( i = 0; i < 15; i++ )
		{
			if ( 0 == i )
				arrBomb[i] = 0;
			else
				arrBomb[i] = 1;
		}
		// ԼϢ
		memset( arrMySqueezerData, 0, 20 );
		// ҵλϢ
		ReadProcessMemory( hOpenHandle, LPVOID(dwMySeatIDBase ),  LPVOID(&byMySeatID ), 1, &dwRealRead  );
		// ȡеϢ
		switch ( byMySeatID )
		{
		case 0:
			for ( i = 0; i < bySqueezerCourrentNum[1]; i++ )
				ReadProcessMemory( hOpenHandle, LPVOID(dwMySqueezerDataBase[1] + i * 0xc ),  LPVOID(&arrMySqueezerData[i] ), 1, &dwRealRead  );
			break;
		case 1:
			for ( i = 0; i < bySqueezerCourrentNum[2]; i++ )
				ReadProcessMemory( hOpenHandle, LPVOID(dwMySqueezerDataBase[2] + i * 0xc ),  LPVOID(&arrMySqueezerData[i] ), 1, &dwRealRead  );
			break;
		case 2:
			for ( i = 0; i < bySqueezerCourrentNum[0]; i++ )
				ReadProcessMemory( hOpenHandle, LPVOID(dwMySqueezerDataBase[0] + i * 0xc ),  LPVOID(&arrMySqueezerData[i] ), 1, &dwRealRead  );
			break;
		}
		dwPlayedTimes = 0;
	}
	if ( bySqueezerCourrentNum[0] == 0 || bySqueezerCourrentNum[1] == 0 || bySqueezerCourrentNum[2] == 0 )
	{
		// ʾֽ
		bGameStart = FALSE;
		for ( int i = 0; i < 3; i++ )
		{
			bySqueezerOldNum[i] = bySqueezerCourrentNum[i] = 0;
		}
		dwPlayedTimes = 0;
	}
}	

// õַ pStrǴڻ, bbWindowNameΪTRUEʾpStrǴ pModleNameʾģ

DWORD GetModuleBase( TCHAR *pStr, BOOL bWindowName, TCHAR *pModleName )
{
	HWND hWnd;
	if ( bWindowName )
		hWnd = FindWindow( NULL, pStr );
	else
		hWnd = FindWindow( pStr, NULL );

	if ( hWnd != NULL  )
	{
		// ģգ ģ
		MODULEENTRY32 me32;
		memset( &me32, 0, sizeof(MODULEENTRY32) );
		me32.dwSize = sizeof( MODULEENTRY32 );
		DWORD dwProcessID;
		GetWindowThreadProcessId( hWnd, &dwProcessID );
		HANDLE hSnapshot = CreateToolhelp32Snapshot( TH32CS_SNAPMODULE, dwProcessID );
		BOOL bRet = Module32First( hSnapshot, &me32 );
		while ( bRet )
		{
			if ( NULL != StrStrI( me32.szExePath, pModleName ) )
			{
				return (DWORD)me32.modBaseAddr;
			}
			bRet = ::Module32Next( hSnapshot, &me32 );
		}
	}
	
	return 0;
}

BOOL bReadMemStart = FALSE;

// ºʾڶԻ
void CQQDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default

	if ( IDT_READMEM == nIDEvent )
	{
		IsGameStart( hOpenHandle );
		if ( bGameStart )
		{
			dwRet = UpToData();
			if ( dwRet )
			{
				UpdateDataToEdit( dwRet - 1 );
			}
		}
		// һֽգ EDIT
		else
		{
			m_edt_csLeft = m_edt_csRight = m_edt_csMySelf = m_edt_csBomb = m_edt_csNotPlayedLeft = m_edt_csNotPlayedRight = _T("");
			UpdateData( FALSE );
		}
	}

	if ( IDT_FINDGAMEWINDOW == nIDEvent )
	{
		hFindWindow = ::FindWindow( NULL, pStr );
		if ( hFindWindow )
		{
			if ( bReadMemStart == FALSE )
			{
				// õϷĴȨ޾
				
				hOpenHandle = GetGameOpenHandl( pStr  );
				
				if ( hOpenHandle != NULL )
				{
					dwGameLogicDllBase = GetModuleBase( pStr, TRUE, pModuleName );
					// MFCĶʱ
					if ( dwGameLogicDllBase != 0 )
					{
						// ʼڴַ
						InitBase();
						SetTimer( IDT_READMEM, 100, NULL );
					}
				}
				bReadMemStart = TRUE;
			}
		}
		// ʾҲϷ ˶ʱ Ҫر
		else
		{
			if ( bReadMemStart == TRUE  )
			{
				KillTimer( IDT_READMEM );
			}
			bReadMemStart = FALSE;

		}

	}

	CDialog::OnTimer(nIDEvent);
}

void CQQDlg::UpdateDataToEdit( DWORD iIndex )
{
	char arrTemp[200];				// ʱִ
	char arrData[200];				// Ƶִ
	char arrBombData[200];				// ըִ
	char arrNotPlayedLeftData[200];		    // û
	char arrNotPlayedRightData[200];
	char arrChar[2] = { 0, 0 };
	memset( arrTemp, 0, 200 );
	memset( arrData, 0, 200 );
	memset( arrBombData, 0, 200 );
	memset( arrNotPlayedLeftData, 0, 200 );
	memset( arrNotPlayedRightData, 0, 200 );
	_asm
	{
		mov eax,eax
	}
	int i, j = 0, iDataIndex = 0;
	//  dwSqueezerData 봫λӦ
	if ( iIndex == 2 )
		iDataIndex = 0;
	else if ( iIndex == 1 )
		iDataIndex = 2;
	else if ( iIndex == 0 )
		iDataIndex = 1;

	for ( i = arrdwSqueezerData[iDataIndex][0]; i != 0; i =arrdwSqueezerData[iDataIndex][j], j++ )
	{
		// 2  10
		if ( arrdwSqueezerData[iDataIndex][j] <= 10 && arrdwSqueezerData[iDataIndex][j] > 1 )
		{	
			// ʾûг
			if ( iIndex == dwPosToSeat[0] )
			{
				arrbyNotPlayedSqueezerData[0][  arrdwSqueezerData[iDataIndex][j] ] = 0;
			}
			else if ( iIndex == dwPosToSeat[1] )
			{
				arrbyNotPlayedSqueezerData[1][  arrdwSqueezerData[iDataIndex][j] ] = 0;
			}
			// ʾܴڵը
			arrBomb[ arrdwSqueezerData[iDataIndex][j] ] = 0;
			itoa( arrdwSqueezerData[iDataIndex][j], arrTemp, 10 );
			lstrcat( arrData, arrTemp );
		}
		// J Q K С
		if ( arrdwSqueezerData[iDataIndex][j] > 10 && arrdwSqueezerData[iDataIndex][j] < 16 )
		{	
			// ʾûг
			if ( iIndex == dwPosToSeat[0] )
			{
				if ( arrdwSqueezerData[iDataIndex][j] ==  15  )
				{
					arrbyNotPlayedSqueezerData[0][ arrdwSqueezerData[iDataIndex][j]-1 ] = 0;
				}
				else
				{
					arrbyNotPlayedSqueezerData[0][  arrdwSqueezerData[iDataIndex][j] ] = 0;
				}
			}
			else if ( iIndex == dwPosToSeat[1] )
			{
				if ( arrdwSqueezerData[iDataIndex][j] ==  15  )
				{
					arrbyNotPlayedSqueezerData[1][ arrdwSqueezerData[iDataIndex][j]-1 ] = 0;
				}
				else
				{
					arrbyNotPlayedSqueezerData[1][  arrdwSqueezerData[iDataIndex][j] ] = 0;
				}
			}
			// ʾܴڵը
			if ( arrdwSqueezerData[iDataIndex][j] != 15 )
			{
				arrBomb[ arrdwSqueezerData[iDataIndex][j] ] = 0;
			}
			else
			{
				arrBomb[ arrdwSqueezerData[iDataIndex][j]-1 ] = 0;
			}

			switch ( arrdwSqueezerData[iDataIndex][j] )
			{
			case 11:
				arrChar[0] = 'J';
				lstrcat( arrData, arrChar );
				break;
			case 12:
				arrChar[0] = 'Q';
				lstrcat( arrData, arrChar );
				break;
			case 13:
				arrChar[0] = 'K';
				lstrcat( arrData, arrChar );
				break;
			case 14:
				lstrcat( arrData, _T("С") );
				break;
			case 15:
				lstrcat( arrData, _T("") );
				break;
			}
		}
		// A
		if ( arrdwSqueezerData[iDataIndex][j] == 1)
		{
			if ( iIndex == dwPosToSeat[0] )
			{
				arrbyNotPlayedSqueezerData[0][  arrdwSqueezerData[iDataIndex][j] ] = 0;
			}
			else if ( iIndex == dwPosToSeat[1] )
			{
				arrbyNotPlayedSqueezerData[1][  arrdwSqueezerData[iDataIndex][j] ] = 0;
			}

			arrBomb[ arrdwSqueezerData[iDataIndex][j] ] = 0;
			arrChar[0] = 'A';
			lstrcat( arrData, arrChar);
		}
	} // endfor
	// ÿγƺϿո
	if ( arrData[0] != 0 )
	{
		arrChar[0] = ' ';
		lstrcat( arrData, arrChar );
	}

	// Ǹһ
	if ( iIndex == dwPosToSeat[0] )
	{
		m_edt_csLeft += arrData;
	}
	else if ( iIndex == dwPosToSeat[1] )
	{
		m_edt_csRight+= arrData;
	}
	else if ( iIndex == dwPosToSeat[2] )
	{
		m_edt_csMySelf+= arrData;
	}
	memset( arrTemp, 0, 200 );
	// ¿ըʾ
	for ( i = 0; i < 20; i++ )
	{
		if ( arrMySqueezerData[i] != 15 )
		{
			arrBomb[ arrMySqueezerData[i] ] = 0;
		}
		else
		{
			arrBomb[ arrMySqueezerData[i] - 1 ] = 0;
		}
	}
	// ըʾ
	for ( i = 0, j=0; i < 15; i++ )
	{
		if ( arrBomb[i] != 0 )
		{
			char *p = "Թ ";
			switch ( i )
			{
			case 1:
				arrChar[0] = 'A';
				lstrcat( arrBombData, arrChar );
				arrChar[0] = ' ';
				lstrcat( arrBombData, arrChar );
				break;
			case 2:
			case 3:
			case 4:
			case 5:
			case 6:
			case 7:
			case 8:
			case 9:
			case 10:
				itoa( i, arrTemp, 10 );
				lstrcat( arrBombData, arrTemp );
				arrChar[0] = ' ';
				lstrcat( arrBombData, arrChar );
				break;
			case 11:
				arrChar[0] = 'J';
				lstrcat( arrBombData, arrChar );
				arrChar[0] = ' ';
				lstrcat( arrBombData, arrChar );
				break;
			case 12:
				arrChar[0] = 'Q';
				lstrcat( arrBombData, arrChar );
				arrChar[0] = ' ';
				lstrcat( arrBombData, arrChar );
				break;
			case 13:
				arrChar[0] = 'K';
				lstrcat( arrBombData, arrChar );
				arrChar[0] = ' ';
				lstrcat( arrBombData, arrChar );
				break;
			case 14:
				lstrcat( arrBombData, p );
				arrChar[0] = ' ';
				lstrcat( arrBombData, arrChar );
				break;
			}
		}
	}
	m_edt_csBomb = arrBombData;
	
	// ѳƱʾ
	for ( i = 0; i < 15; i++ )
	{
		if ( arrbyNotPlayedSqueezerData[0][i] != 0 )
		{
			char *p = " ";
			switch ( i )
			{
			case 1:
				arrChar[0] = 'A';
				lstrcat( arrNotPlayedLeftData, arrChar );
				arrChar[0] = ' ';
				lstrcat( arrNotPlayedLeftData, arrChar );
				break;
			case 2:
			case 3:
			case 4:
			case 5:
			case 6:
			case 7:
			case 8:
			case 9:
			case 10:
				itoa( i, arrTemp, 10 );
				lstrcat( arrNotPlayedLeftData, arrTemp );
				arrChar[0] = ' ';
				lstrcat( arrNotPlayedLeftData, arrChar );
				break;
			case 11:
				arrChar[0] = 'J';
				lstrcat( arrNotPlayedLeftData, arrChar );
				arrChar[0] = ' ';
				lstrcat( arrNotPlayedLeftData, arrChar );
				break;
			case 12:
				arrChar[0] = 'Q';
				lstrcat( arrNotPlayedLeftData, arrChar );
				arrChar[0] = ' ';
				lstrcat( arrNotPlayedLeftData, arrChar );
				break;
			case 13:
				arrChar[0] = 'K';
				lstrcat( arrNotPlayedLeftData, arrChar );
				arrChar[0] = ' ';
				lstrcat( arrNotPlayedLeftData, arrChar );
				break;
			case 14:
				lstrcat( arrNotPlayedLeftData, p );
				arrChar[0] = ' ';
				lstrcat( arrNotPlayedLeftData, arrChar );
				break;
			}
		}
	}

	for ( i = 0; i < 15; i++ )
	{
		if ( arrbyNotPlayedSqueezerData[1][i] != 0 )
		{
			char *p = " ";
			switch ( i )
			{
			case 1:
				arrChar[0] = 'A';
				lstrcat( arrNotPlayedRightData, arrChar );
				arrChar[0] = ' ';
				lstrcat( arrNotPlayedRightData, arrChar );
				break;
			case 2:
			case 3:
			case 4:
			case 5:
			case 6:
			case 7:
			case 8:
			case 9:
			case 10:
				itoa( i, arrTemp, 10 );
				lstrcat( arrNotPlayedRightData, arrTemp );
				arrChar[0] = ' ';
				lstrcat( arrNotPlayedRightData, arrChar );
				break;
			case 11:
				arrChar[0] = 'J';
				lstrcat( arrNotPlayedRightData, arrChar );
				arrChar[0] = ' ';
				lstrcat( arrNotPlayedRightData, arrChar );
				break;
			case 12:
				arrChar[0] = 'Q';
				lstrcat( arrNotPlayedRightData, arrChar );
				arrChar[0] = ' ';
				lstrcat( arrNotPlayedRightData, arrChar );
				break;
			case 13:
				arrChar[0] = 'K';
				lstrcat( arrNotPlayedRightData, arrChar );
				arrChar[0] = ' ';
				lstrcat( arrNotPlayedRightData, arrChar );
				break;
			case 14:
				lstrcat( arrNotPlayedRightData, p );
				arrChar[0] = ' ';
				lstrcat( arrNotPlayedRightData, arrChar );
				break;
			}
		}
	}

	m_edt_csNotPlayedLeft = arrNotPlayedLeftData;
	m_edt_csNotPlayedRight = arrNotPlayedRightData;

	UpdateData( FALSE );
	// ձݵ飬Ϊһζȡ׼
	memset( arrdwSqueezerData, 0, 3*20*4 );

}
